TupleTupleKeyCreator (Oracle - Berkeley DB Java API)
Date: 2017-04-13

com.sleepycat.bind.tuple

## Class TupleTupleKeyCreator<E>

- java.lang.Object
- - com.sleepycat.bind.tuple.TupleBase<E>
  - - com.sleepycat.bind.tuple.TupleTupleKeyCreator<E>

- All Implemented Interfaces:
    ForeignKeyNullifier, SecondaryKeyCreator
  Direct Known Subclasses:
    TupleTupleMarshalledKeyCreator

      public abstract class TupleTupleKeyCreator<E>
      extends TupleBase<E>
      implements SecondaryKeyCreator, ForeignKeyNullifier

  An abstract key creator that uses a tuple key and a tuple data entry. This class takes care of converting the key and data entry to/from `TupleInput` and `TupleOutput` objects. The following abstract method must be implemented by a concrete subclass to create the index key using these objects
  - `createSecondaryKey(TupleInput,TupleInput,TupleOutput)`

  If `ForeignKeyDeleteAction.NULLIFY` was specified when opening the secondary database, the following method must be overridden to nullify the foreign index key. If NULLIFY was not specified, this method need not be overridden.

  - `nullifyForeignKey(TupleInput,TupleOutput)`

  If `ForeignKeyDeleteAction.NULLIFY` was specified when creating the secondary, this method is called when the entity for this foreign key is deleted. If NULLIFY was not specified, this method will not be called and may always return false.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TupleTupleKeyCreator()` Creates a tuple-tuple key creator.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `createSecondaryKey(SecondaryDatabase db, DatabaseEntry primaryKeyEntry, DatabaseEntry dataEntry, DatabaseEntry indexKeyEntry)` Creates a secondary key entry, given a primary key and data entry.
    `abstract boolean` | `createSecondaryKey(TupleInput primaryKeyInput, TupleInput dataInput, TupleOutput indexKeyOutput)` Creates the index key from primary key tuple and data tuple.
    `boolean` | `nullifyForeignKey(SecondaryDatabase db, DatabaseEntry dataEntry)` Sets the foreign key reference to null in the datum of the primary database.
    `boolean` | `nullifyForeignKey(TupleInput dataInput, TupleOutput dataOutput)` Clears the index key in the tuple data entry.

    - ### Methods inherited from class com.sleepycat.bind.tuple.TupleBase

      `entryToInput, getTupleBufferSize, getTupleOutput, inputToEntry, newOutput, newOutput, outputToEntry, setTupleBufferSize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TupleTupleKeyCreator

          public TupleTupleKeyCreator()

      Creates a tuple-tuple key creator.

  - ### Method Detail

    - #### createSecondaryKey

          public boolean createSecondaryKey(SecondaryDatabase db,
                                            DatabaseEntry primaryKeyEntry,
                                            DatabaseEntry dataEntry,
                                            DatabaseEntry indexKeyEntry)

      Description copied from interface: `SecondaryKeyCreator`
      Creates a secondary key entry, given a primary key and data entry.

      A secondary key may be derived from the primary key, primary data, or a combination of the primary key and data. For secondary keys that are optional, the key creator method may return false and the key/data pair will not be indexed. To ensure the integrity of a secondary database the key creator method must always return the same result for a given set of input parameters.

      Specified by:
        `createSecondaryKey` in interface `SecondaryKeyCreator`
      Parameters:
        `db` - the database to which the secondary key will be added. This parameter is passed for informational purposes but is not commonly used.

        `primaryKeyEntry` - the primary key entry. This parameter must not be modified by this method.

        `dataEntry` - the primary data entry. This parameter must not be modified by this method.

        `indexKeyEntry` - the secondary key created by this method.

      Returns:
        true if a key was created, or false to indicate that the key is not present.

    - #### nullifyForeignKey

          public boolean nullifyForeignKey(SecondaryDatabase db,
                                           DatabaseEntry dataEntry)

      Description copied from interface: `ForeignKeyNullifier`
      Sets the foreign key reference to null in the datum of the primary database.
      Specified by:
        `nullifyForeignKey` in interface `ForeignKeyNullifier`
      Parameters:
        `db` - the database in which the foreign key integrity constraint is defined. This parameter is passed for informational purposes but is not commonly used.
        `dataEntry` - the existing primary datum in which the foreign key reference should be set to null. This parameter should be updated by this method if it returns true.
      Returns:
        true if the datum was modified, or false to indicate that the key is not present.

    - #### createSecondaryKey

          public abstract boolean createSecondaryKey(TupleInput primaryKeyInput,
                                                     TupleInput dataInput,
                                                     TupleOutput indexKeyOutput)

      Creates the index key from primary key tuple and data tuple.
      Parameters:
        `primaryKeyInput` - is the `TupleInput` for the primary key entry.
        `dataInput` - is the `TupleInput` for the data entry.
        `indexKeyOutput` - is the destination index key tuple.
      Returns:
        true if a key was created, or false to indicate that the key is not present.

    - #### nullifyForeignKey

          public boolean nullifyForeignKey(TupleInput dataInput,
                                           TupleOutput dataOutput)

      Clears the index key in the tuple data entry. The dataInput should be read and then written to the dataOutput, clearing the index key in the process.

      The secondary key should be output or removed by this method such that `createSecondaryKey(com.sleepycat.db.SecondaryDatabase, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry)` will return false. Other fields in the data object should remain unchanged.

      Parameters:
        `dataInput` - is the `TupleInput` for the data entry.
        `dataOutput` - is the destination `TupleOutput`.
      Returns:
        true if the key was cleared, or false to indicate that the key is not present and no change is necessary.

Copyright (c) 1996, 2017 Oracle and/or its affiliates. All rights reserved.